// Definizione e testing di due versioni di una funzione che decide
// se un numero intero è pari

// inclusione dell'header file della libreria standard di
// definizioni di macro, costanti e dichiarazioni di funzioni e tipi
// per le varie operazioni di input/output

#include <stdio.h>

// definizione di una prima versione della funzione

int pari_1 (int x)
   // Parametri formali
   //    x:      valore del quale si testa la parita'
   {
   // se divido x per 2 e il resto e' 0, allora x e' pari e restituisco 1.
   // E' dispari altrimenti e restituisco 0
   if ((x % 2) == 0)
     return (1);
   else
     return(0);
   }

// definizione della seconda versione della funzione
   
int pari_2 (int x)
   // Parametri formali
   //    x:      valore del quale si testa la parita'
   {
   // se divido x per 2 e il resto e' 0, allora x e' pari e restituisco 1.
   // E' dispari altrimenti e restituisco 0
   return(!(x%2));
   }
   
// Testing della funzione

int main()
   {
   // definizione della variabile per l'input
   int a;

   // acquisisco l'input
   printf("\nDammi il valore da testare: ");
   scanf("%d", &a);
   
   // testo se l'input e' pari e visualizzo il risultato del test
   if(pari_1(a))
     printf("\n%d e' pari", a);
   else
     printf("\n%d e' dispari", a);
 
   return(0);
   }
